<template>
  <v-card>
    <v-card-title class="headline">
      Dept Developers
    </v-card-title>
    <v-card-text>
      <organization-chart :datasource="orgDevelopers" />
    </v-card-text>
  </v-card>
</template>

<script>
import OrganizationChart from 'vue-organization-chart'
import 'vue-organization-chart/dist/orgchart.css'

export default {
  components: {
    OrganizationChart
  },
  data() {
    return {
      ds: {
        id: '1',
        name: 'Lao Lao',
        title: 'general manager',
        children: [
          { id: '2', name: 'Bo Miao', title: 'department manager' },
          {
            id: '3',
            name: 'Su Miao',
            title: 'department manager',
            children: [
              { id: '4', name: 'Tie Hua', title: 'senior engineer' },
              {
                id: '5',
                name: 'Hei Hei',
                title: 'senior engineer',
                children: [
                  { id: '6', name: 'Pang Pang', title: 'engineer' },
                  { id: '7', name: 'Xiang Xiang', title: 'UE engineer' }
                ]
              }
            ]
          },
          { id: '8', name: 'Hong Miao', title: 'department manager' },
          { id: '9', name: 'Chun Miao', title: 'department manager' }
        ]
      }
    }
  },
  computed: {
    headDeveloper() {
      return this.$store.state.developers.headDeveloper
    },
    developers() {
      return this.$store.state.developers.developers
    },
    orgDevelopers() {
      return this.orgData(
        this.$store.state.developers.developers.filter(developer => {
          return developer.fields.leader === true
        })[0]
      )
    }
  },
  async fetch({ store, params }) {
    await store.dispatch('developers/getHeadDeveloper', params.slug)
    await store.dispatch('developers/getDevelopers', params.slug)
  },
  methods: {
    orgData: function(employee) {
      const orgEmployee = {
        id: employee.sys.id,
        name: employee.fields.firstName + ' ' + employee.fields.lastName,
        title: employee.fields.title,
        employees: employee.fields.employees
      }

      if (employee.fields.employees && employee.fields.employees.length > 0) {
        orgEmployee.children = this.orgChildren(employee.fields.employees)
      }

      return orgEmployee
    },
    orgChildren: function(employees) {
      const orgEmployees = []
      const that = this
      employees.forEach(function(childEmployee) {
        orgEmployees.push(that.orgData(childEmployee))
      })
      return orgEmployees
    }
  }
}
</script>
